// common.h
// KCO 2010.5.24
#ifndef __COMMON_H
#define __COMMON_H

#include "stm32f10x.h"
#include "stm32f10x_usart.h"
#include <stdarg.h>
#include <stdio.h>

#define BOOL		char
#define BYTE		unsigned char
#define WORD		unsigned int
#define LONG		unsigned long

#define HIGH 		1
#define LOW  		0
#define TRUE		1
#define FALSE		0

#define CR  		0x0d
#define LF  		0x0a

#define ON_LED1     (GPIOC->BRR = GPIO_Pin_9)
#define OFF_LED1    (GPIOC->BSRR = GPIO_Pin_9)
#define T_LED1      (GPIOC->ODR ^= GPIO_Pin_9)

#define ON_LED2     (GPIOC->BRR = GPIO_Pin_8)
#define OFF_LED2    (GPIOC->BSRR = GPIO_Pin_8)
#define T_LED2      (GPIOC->ODR ^= GPIO_Pin_8)

#define TXEN1_ENABLE    (GPIOA->BSRR = GPIO_Pin_8)
#define TXEN1_DISABLE   (GPIOA->BRR  = GPIO_Pin_8)
#define TXEN2_ENABLE    (GPIOA->BSRR = GPIO_Pin_4)
#define TXEN2_DISABLE   (GPIOA->BRR  = GPIO_Pin_4)
#define TXEN3_ENABLE    (GPIOB->BSRR = GPIO_Pin_12)
#define TXEN3_DISABLE   (GPIOB->BRR  = GPIO_Pin_12)

#define	KEY_DOWN	1
#define	KEY_UP		2
#define	KEY_CONT	3

void delay_us(u32 nCount);
void delay_ms(u32 nCount);
BYTE asc2hex(BYTE asc);
BYTE hex2asc(BYTE hex);
WORD hex2_to_decimal(BYTE b);
LONG hex4_to_decimal(WORD w);
long map(long x, long in_min, long in_max, long out_min, long out_max);
float map_f(float x, float in_min, float in_max, float out_min, float out_max);
void check_period_flag(void);

extern BOOL flag_1ms,flag_2ms,flag_10ms,flag_100ms,flag_300ms;

#endif /* __COMMON_H */
