// KCO 2010.6.5
// main.c
#include <intrinsics.h>
#include "stm32f10x.h"
#include "common.h"
#include "lcd.h"
#include "key.h"
#include "timer.h"

int mcnt=0;

extern u16 pul1_width,pul1_period;
extern u16 pul2_width,pul2_period;
extern u16 cap1_cnt,cap2_cnt;

u16 cap1_cnt_b=0,cap2_cnt_b=0;

void	key_down_proc(BYTE c){
	switch(c){
		case 0: 
 			break;
		case 1:
            break;
		case 2:
			break;
		case 3:
			break;
		case 4:
 			break;
		default:	
			break;
	}
}

void	key_up_proc(BYTE c){
	switch(c){
		case 0:
			break;
		case 1:
			break;
		case 2:
			break;
		case 3:
			break;
		case 4:
			break;
		default:	
			break;
	}
}
BYTE	key_cnt=0;
void	key_cont_proc(BYTE c){
	switch(c){
		case 0:
 			break;
		case 1:
			break;
		case 2:
			break;
		case 3:
			break;
		case 4:
			break;
		default:	
			break;
	}
}

WORD	key_code;
void	key_process(void){
WORD	i,c;
	key_code = key5_proc();
	for(i=0;i<5;i++){
	  	c = (key_code>>(2*i) )& 0x03;
		if(c == KEY_CONT) key_cont_proc(i);
		else if(c == KEY_DOWN) key_down_proc(i);
		else if(c == KEY_UP) key_up_proc(i);
	}
}

void TIM1_UP_IRQHandler(void){  // Timer1 interrupt routine
    // Clear update interrupt bit
    TIM_ClearITPendingBit(TIM1,TIM_FLAG_Update);
    check_period_flag();
}


void main(void){
NVIC_InitTypeDef NVIC_InitStructure;
TIM_TimeBaseInitTypeDef TIM1_TimeBaseInitStruct;

    /* Setup STM32 system (clock, PLL and Flash configuration) */
    SystemInit();
    
    /* Set the Vector Table base location at 0x08000000 */
    NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);
    
    //*********************** GPIO Init *****************************
    // Enable GPIO clock and release reset
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA |
                         RCC_APB2Periph_GPIOB |
                         RCC_APB2Periph_GPIOC,
                         ENABLE);
    RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOA |
                         RCC_APB2Periph_GPIOB |
                         RCC_APB2Periph_GPIOC,
                         DISABLE);
    
    //************************ Timer1 Init **************************
    // Enable Timer1 clock and release reset
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1,ENABLE);
    RCC_APB2PeriphResetCmd(RCC_APB2Periph_TIM1,DISABLE);
    
    // Set timer period 100 usec
    TIM1_TimeBaseInitStruct.TIM_Prescaler = 72-1;  // 1us resolution
    TIM1_TimeBaseInitStruct.TIM_CounterMode = TIM_CounterMode_Up;
    TIM1_TimeBaseInitStruct.TIM_Period = 100;  // 100 us
    TIM1_TimeBaseInitStruct.TIM_ClockDivision = TIM_CKD_DIV2;   // for 36MHz
    TIM1_TimeBaseInitStruct.TIM_RepetitionCounter = 0;
    TIM_TimeBaseInit(TIM1,&TIM1_TimeBaseInitStruct);
    // Clear update interrupt bit
    TIM_ClearITPendingBit(TIM1,TIM_FLAG_Update);
    // Enable update interrupt
    TIM_ITConfig(TIM1,TIM_FLAG_Update,ENABLE);
    
    NVIC_InitStructure.NVIC_IRQChannel = TIM1_UP_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 7;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    // Enable timer counting
    TIM_Cmd(TIM1,ENABLE);

	lcd_init(20,4);
    init_key();
    init_tim_cap();
    
    __enable_interrupt();

//	lcd_gotoxy(0,0);
//	lcd_puts("*** TIM_CAP Test ***");
     
    while(1){
        
	    if(flag_1ms){
	    	flag_1ms = 0;
	    }
	    if(flag_2ms){
	    	flag_2ms = 0;
	    }
	    if(flag_10ms){
	    	flag_10ms = 0;
			key_process();
		}
	    if(flag_100ms){
	    	flag_100ms = 0;

            if(cap1_cnt == cap1_cnt_b) pul1_period = pul1_width = 0;
            else cap1_cnt_b = cap1_cnt;

            if(cap2_cnt == cap2_cnt_b) pul2_period = pul2_width = 0;
            else cap2_cnt_b = cap2_cnt;
		}
	    if(flag_300ms){
	    	flag_300ms = 0;
            mcnt++;
//            lcd_gotoxy(0,1);
//            lcd_printf("mcnt=%04X(%5d)",mcnt,mcnt);

            lcd_gotoxy(0,0);
            lcd_printf("Peri_1=%04X(%5d)us",pul1_period,pul1_period);
            lcd_gotoxy(0,1);
            lcd_printf("Width1=%04X(%5d)us",pul1_width,pul1_width);
            
            lcd_gotoxy(0,2);
            lcd_printf("Peri_2=%04X(%5d)us",pul2_period,pul2_period);
            lcd_gotoxy(0,3);
            lcd_printf("Width2=%04X(%5d)us",pul2_width,pul2_width);
		}
    }
}
